
// AX_Annot_DemoDlg.h : header file
//

#pragma once

#include "foxitpdfsdkproctrl.h"
#include "CPDFormatTool.h"
#include "CPDFAnnot.h"
#include "CPDFPageAnnots.h"

#include "AnnotInfoDlg.h"
#include "AnnotReplyDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CAX_Annot_DemoDlg dialog
class CAX_Annot_DemoDlg : public CDialog
{
// Construction
public:
	CAX_Annot_DemoDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	enum { IDD = IDD_AX_ANNOT_DEMO_DIALOG };
	CComboBox	m_linkPageIndexCombo;
	CComboBox	m_linkActionTypeCombo;
	CComboBox	m_annotToolsCombo;
	CComboBox	m_mediaContentTypeCombo;
	CSliderCtrl	m_opacitySlider;
	CListBox	m_thickNessList;
	CComboBox	m_annotSubTypeCombo;
	short	m_nOpacity;
	BOOL	m_bLockCheck;
	BOOL	m_bPopupCheck;
	BOOL	m_bPrintCheck;
	BOOL	m_bReadonlyCheck;
	CString	m_strLeftPos;
	CString	m_strRightPos;
	CString	m_strTopPos;
	CString	m_strBottomPos;
	int		m_nBroderStyle;
	int		m_nLineStartStyle;
	int		m_nLineEndStyle;
	CString	m_strAuthor;
	CString	m_strSubject;
	int		m_nReviewState;
	int		m_nMarkedState;
	CString	m_strDescription;
	CString	m_strCreateDate;
	CString	m_strModifyDate;
	CString	m_strFilePath;
	int		m_nMigrationState;
	CString	m_strContents;
	CString	m_strFontName;
	CString	m_strFontSize;
	int		m_nAlignStyle;
	BOOL	m_bFontBold;
	BOOL	m_bFontItalic;
	CString	m_strCharSpace;
	CString	m_strCharHorzScale;
	BOOL	m_bEmbedMedia;
	BOOL	m_bShowCtrlBar;
	CString	m_strPoint3XPos;
	CString	m_strPoint3YPos;
	CString	m_strPoint4XPos;
	CString	m_strPoint4YPos;
	CString	m_strWebURL;
	CString	m_strLinkActionPageLeft;
	CString	m_strLinkActionPageTop;
	CString	m_strImagePath;
	CFoxitPDFSDK	m_fxAXSDK;
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support


// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnOnOpenDocumentFoxitpdfsdkproctrl1(LPCTSTR FilePath);
	afx_msg void OnAddAnnotBtn();
	afx_msg void OnColorBtn();
	afx_msg HBRUSH OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor);
	afx_msg void OnDrawItem(int nIDCtl, LPDRAWITEMSTRUCT lpDrawItemStruct);
	afx_msg void OnFillColorBtn();
	afx_msg void OnSelchangeAnnotSubtypeCombo();
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnChangeOpacityEdit();
	afx_msg void OnOnCloseDocumentFoxitpdfsdkproctrl1(LPCTSTR FilePath);
	afx_msg void OnRemoveAnnotBtn();
	afx_msg void OnModifyAnnotBtn();
	afx_msg void OnChooseFileBtn();
	afx_msg void OnChangeLeftEdit();
	afx_msg void OnChangeRightEdit();
	afx_msg void OnChangeTopEdit();
	afx_msg void OnChangeBottomEdit();
	afx_msg void OnClose();
	afx_msg void OnChooseFontBtn();
	afx_msg void OnFontColorBtn();
	afx_msg void OnBorderColorBtn();
	afx_msg void OnFontFillColorBtn();
	afx_msg void OnFontBoldCheck();
	afx_msg void OnFontItalicCheck();
	afx_msg void OnLeftAlignRadio();
	afx_msg void OnMiddleAlignRadio();
	afx_msg void OnRightAlignRadio();
	afx_msg void OnChangeCharSpaceEdit();
	afx_msg void OnChangeCharHorzScaleEdit();
	afx_msg void OnChangeTool();
	afx_msg void OnSelchangeLinkActionCombo();
	afx_msg void OnChooseImageBtn();
	afx_msg void OnAnnotInfoBtn();
	afx_msg void OnReplyModule();
	afx_msg void OnOK();
	DECLARE_EVENTSINK_MAP()
	DECLARE_MESSAGE_MAP()
private:
	CMap<int, int, CPDFAnnot, CPDFAnnot> m_AnnotMap;
	CRect m_rcOriginal;
	COLORREF m_color;
	COLORREF m_fillColor;
	COLORREF m_fontColor;
	COLORREF m_fontBorderColor;
	COLORREF m_fontFillColor;
	CAnnotInfoDlg* m_pAnnotInfoDlg;
	CAnnotReplyDlg*  m_pAnnotRepleDlg;
private:
	void ClearAllCtrlContents();
	void DisableAllCtrl();
	void GetTime_TimeZoom(CPDFAnnot pPDFAnnot);
	void EnableSimialSquareCtrl(BOOL bEnable);
	void SetSimilarSquareCtrlProperties(CPDFAnnot pPDFAnnot);
	void EnableSimilarArrowCtrl(BOOL bEnable);
	void SetSimilarArrowCtrlProperties(CPDFAnnot pPdfAnnot);
	void EnableSimilarUnderLineCtrl(BOOL bEnable);
	void SetSimilarUnderLineCtrlProperties(CPDFAnnot pPdfAnnot);
	void EnableTypeWriterCtrl(BOOL bEnable);
	void SetTypeWriterCtrlProperties(CPDFAnnot pPDFAnnot);
	void EnableSimilarTextBoxCtrl(BOOL bEnable);
	void SetSimilarTextBoxCtrlProperties(CPDFAnnot pPDFAnnot);
	void EnableSimilarFilePathCtrl(BOOL bEnable);
	void SetSimilarFilePathCtrlProperties(CPDFAnnot pPDFAnnot);
	void EnablePencilCtrl(BOOL bEnable);
	void SetPencilCtrlProperties(CPDFAnnot pPDFAnnot);
	void EnableSimilarLinkCtrl(BOOL bEnable);
	void SetSimilarLinkCtrlProperties(CPDFAnnot pPDFAnnot);

	void EnableFormatToolCtrl(BOOL bEnable);
	void ClearFormatToolCtrlContents();
	void GetFormatToolParameters();

	BOOL CheckAnnotAddin();
	void SetAnnotParametersInCtrl(CPDFAnnot pPDFAnnot);
	void ModifyAnnotParameters(CPDFAnnot pPDFAnnot);
	void SetMediaContentType(BOOL nType = TRUE);
	void EnableLinkActionOptions(BOOL bOption);
public:
	afx_msg void OnEnChangeAuthorEdit();
	afx_msg void OnEnChangeSubjectEdit();
	afx_msg void OnBnClickedLockCheck();
	afx_msg void OnEnChangeContentEdit();
	afx_msg void OnBnClickedPrintCheck();
	afx_msg void OnBnClickedReadonlyCheck();
	afx_msg void OnBnClickedPopupCheck();
	afx_msg void OnCbnSelchangeBorderStyleCombo();
	afx_msg void OnCbnSelchangeLineStartStyleCombo();
	afx_msg void OnCbnSelchangeLineEndStyleCombo();
	afx_msg void OnCbnSelchangeReviewStateCombo();
	afx_msg void OnCbnSelchangeMarkedStateCombo();
	afx_msg void OnCbnSelchangeMigrationStateCombo();
};
