// FindFoldDlg.cpp : implementation file
//

#include "stdafx.h"
#include "AX_Pro_Demo.h"
#include "FindFoldDlg.h"

#include "foxitpdfsdkproctrl.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CFindFoldDlg dialog


CFindFoldDlg::CFindFoldDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CFindFoldDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CFindFoldDlg)
	m_matchcase = FALSE;
	m_matchwholeworld = FALSE;
	m_what = _T("");
	m_fold = _T("");
	//}}AFX_DATA_INIT
}


void CFindFoldDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFindFoldDlg)
	DDX_Control(pDX, IDC_TREE1, m_findtree);
	DDX_Check(pDX, IDC_CHECK1, m_matchcase);
	DDX_Check(pDX, IDC_CHECK2, m_matchwholeworld);
	DDX_Text(pDX, IDC_EDIT1, m_what);
	DDX_Text(pDX, IDC_PATH, m_fold);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CFindFoldDlg, CDialog)
	//{{AFX_MSG_MAP(CFindFoldDlg)
	ON_BN_CLICKED(IDC_SelectFold, OnSelectFold)
	ON_BN_CLICKED(IDC_StartSearch, OnStartSearch)
	ON_NOTIFY(NM_CLICK, IDC_TREE1, OnClickTree1)
	ON_BN_CLICKED(IDC_CANCEL, OnCancel)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFindFoldDlg message handlers

int SelFolder(HWND hParent, CString &strFolder)
{
    strFolder.Empty();
 
    LPMALLOC lpMalloc;
 
    if (::SHGetMalloc(&lpMalloc) != NOERROR) return 0;
 
    WCHAR szDisplayName[_MAX_PATH];
    WCHAR szBuffer[_MAX_PATH];
    BROWSEINFO browseInfo;
    browseInfo.hwndOwner = hParent;
    browseInfo.pidlRoot = NULL; // set root at Desktop
    browseInfo.pszDisplayName = szDisplayName;
    browseInfo.lpszTitle = _T("Select a folder");
    browseInfo.ulFlags = BIF_RETURNFSANCESTORS|BIF_RETURNONLYFSDIRS;
    browseInfo.lpfn = NULL;
    browseInfo.lParam = 0;
 
    LPITEMIDLIST lpItemIDList;
    if ((lpItemIDList = ::SHBrowseForFolder(&browseInfo)) != NULL)
    {
        // Get the path of the selected folder from the    item ID list.
        if (::SHGetPathFromIDList(lpItemIDList, szBuffer))
        {
            // At this point, szBuffer contains the path the user chose.
            if (szBuffer[0] == '\0') return 0;
 
            // We have a path in szBuffer! Return it.
            strFolder = szBuffer;
            return 1;
        }
        else return 1; // strResult is empty
 
        lpMalloc->Free(lpItemIDList);
        lpMalloc->Release();
    }
    
 return 1;
} 


void CFindFoldDlg::OnSelectFold() 
{
	SelFolder(m_hWnd,m_strFolder);
	m_fold=m_strFolder;
	UpdateData(FALSE);

	// TODO: Add your control notification handler code here
	
}

void CFindFoldDlg::OnStartSearch() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	m_findtree.DeleteAllItems();
	m_findMap.RemoveAll();
    
	CFileFind  ff;
	CString strFolder=m_strFolder;
	if( strFolder.Right(1) != "\\")	
		strFolder += "\\";
	strFolder += _T("*.pdf");
    BOOL res = ff.FindFile(strFolder);
	int nCount = 0;
	CString csTemp;

	while(res)
	{
		res = ff.FindNextFile();
		CString strFileName = ff.GetFilePath();
//		CFindResult result=	m_pAX->FindFileFirst(strFileName, m_what,m_matchcase,m_matchwholeworld);
	
/************************************************************************/
/*   FindFileFirstEx()                                          
	 test by zg                                                         */
/************************************************************************/   
		VARIANT var;
		BSTR bstr = m_what.AllocSysString();
		int  num = m_what.GetLength();
		
		SAFEARRAY *psa;   
		SAFEARRAYBOUND rgsabound[1];   
		rgsabound[0].cElements =num;   
		rgsabound[0].lLbound = 0;   
		psa = SafeArrayCreate(VT_UI2,1,rgsabound);
		for(long index=0; index<num; index++)   
		{   
			if(FAILED(SafeArrayPutElement(psa, &index, &bstr[index])))
				return;
		}   
		var.vt = VT_ARRAY | VT_UI2;
		var.parray = psa;
		
		CFindResult result = m_pAX->FindFileFirstEx(strFileName,NULL, var, m_matchcase, m_matchwholeworld);
		SafeArrayDestroy(psa);
//end by zg

		while(result!=NULL)
		{    
			csTemp.Format(_T("%i:%s"), nCount++, m_what);
			TVINSERTSTRUCT tvis;
			HTREEITEM hItem = NULL;
			tvis.hParent = NULL;
			tvis.hInsertAfter = TVI_LAST;
			tvis.item.mask = TVIF_TEXT | TVIF_CHILDREN;
			tvis.item.pszText = csTemp.LockBuffer();
			hItem = m_findtree.InsertItem (&tvis);
			csTemp.ReleaseBuffer();
			m_findMap.SetAt ( hItem, result );
            result = m_pAX->FindFileNext();
		}
		
	}
	ff.Close();
	
}

void CFindFoldDlg::OnClickTree1(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here
	DWORD dw=GetMessagePos();
	POINTS ps= MAKEPOINTS(dw);	
	CPoint pt;
	pt.x = ps.x;
	pt.y = ps.y;
	CFindResult result;
	
	m_findtree.ScreenToClient( &pt );
	UINT uFlags;
	HTREEITEM hItem = m_findtree. HitTest( pt, &uFlags );
	
	if ( NULL != hItem && TVHT_ONITEM & uFlags )
	{     
		if ( m_findMap.Lookup ( hItem, result ) )
		{
			if (  result )
			{
				CString a=m_pAX->GetFilePath();
				
				if(a != result.GetFindFileName())
					m_pAX->OpenFile(result.GetFindFileName(),_T(""));	
				m_pAX->GoToSearchResult(result);

/************************************************************************/
/*   GetFindPageNum()      GetFindString                                    
	 test by zg															*/
/************************************************************************/
	long lPageNum = result.GetFindPageNum();
	CString strFind = result.GetFindString();
//end by zg

// 				m_pAX->GotoPage( result.GetFindPageNum() );
// 				m_pAX->RemoveAllHighlight();
// 				m_pAX->SearchAndHighlightAllTextOnPage( m_what,
// 				m_matchcase, m_matchwholeworld, result.GetFindPageNum() );
			}
			
		}
	}
	
	*pResult = 0;
}

void CFindFoldDlg::OnOK() 
{    
	CDialog::OnOK();
	DestroyWindow();
}

void CFindFoldDlg::OnCancel() 
{
	CDialog::OnCancel();
	DestroyWindow();
}

void CFindFoldDlg::init(CFoxitPDFSDK* pAX)
{
	m_pAX = pAX;
}
