// AnnotInfoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "AX_Annot_Demo.h"
#include "AnnotInfoDlg.h"
#include "foxitpdfsdk.h"
#include "pdfpageannots.h"
#include "pdfannot.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAnnotInfoDlg dialog


CAnnotInfoDlg::CAnnotInfoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CAnnotInfoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CAnnotInfoDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}

CAnnotInfoDlg::CAnnotInfoDlg(CFoxitPDFSDK* pAXSDK, CWnd* pParent /* = NULL */)
: CDialog(CAnnotInfoDlg::IDD, pParent)
{
	m_pFxAXSDK = pAXSDK;
}

void CAnnotInfoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAnnotInfoDlg)
	DDX_Control(pDX, IDC_ANNOT_INFO_LIST, m_annotInfoList);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CAnnotInfoDlg, CDialog)
	//{{AFX_MSG_MAP(CAnnotInfoDlg)
	ON_BN_CLICKED(IDC_OK_BTN, OnOkBtn)
	ON_NOTIFY(NM_DBLCLK, IDC_ANNOT_INFO_LIST, OnDblclkAnnotInfoList)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAnnotInfoDlg message handlers

BOOL CAnnotInfoDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	CRect rect;
	m_annotInfoList.GetClientRect(&rect);
	int width = rect.Width() / 3;
	m_annotInfoList.InsertColumn(0, _T("Annot Index"), LVCFMT_CENTER, width);
	LVCOLUMN lvc;
	lvc.mask = LVCF_FMT;
	m_annotInfoList.GetColumn(0, &lvc);
	lvc.fmt &= ~LVCFMT_JUSTIFYMASK;
	lvc.fmt |= LVCFMT_CENTER;
	m_annotInfoList.SetColumn(0, &lvc);
	m_annotInfoList.InsertColumn(1, _T("Annot Type"), LVCFMT_CENTER, width);
	m_annotInfoList.InsertColumn(2, _T("Annot SubType"), LVCFMT_CENTER, width);
	m_annotInfoList.SetExtendedStyle(LVS_EX_FLATSB    
		| LVS_EX_FULLROWSELECT      
		| LVS_EX_HEADERDRAGDROP     
		| LVS_EX_ONECLICKACTIVATE    
		|LVS_EX_GRIDLINES);      

	UpdateInfo();
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CAnnotInfoDlg::OnOkBtn() 
{
	// TODO: Add your control notification handler code here
	UpdateInfo();
}

void CAnnotInfoDlg::OnDblclkAnnotInfoList(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here
	NMLISTVIEW* pListView = (NMLISTVIEW*)pNMHDR;
	int nIndex = pListView->iItem;
	
	CPDFPageAnnots pPageAnnots = m_pFxAXSDK->GetPageAnnots(m_pFxAXSDK->GetCurPage());
	if(!pPageAnnots)
	{
		MessageBox(_T("Please check the KEY license information.\n\nIf you never have a KEY license ,please contact us at sales@foxitsoftware.com"));
		return;
	}

	CPDFAnnot pAnnot = pPageAnnots.GetAnnot(nIndex);
	if(pAnnot.GetType() == _T("Link") && pAnnot.HasAction())
	{
		pAnnot.DoAction();
	}
	else if (pAnnot.GetType() == _T("Line"))
	{
		float fStartX, fStartY, fEndX, fEndY;
        pAnnot.GetStartingPoint(&fStartX, &fStartY);
		pAnnot.GetEndingPoint(&fEndX, &fEndY);
		
        fStartX += 100;
		fStartY += 100;
		fEndX += 100;
		fEndY += 100;
        
		pAnnot.SetStartingPoint(fStartX, fStartY);
		pAnnot.SetEndingPoint(fEndX, fEndY);
	}
	if(pAnnot.HasPopup()) 
	{
		pAnnot.SetPopupOpen(TRUE);
	}

	*pResult = 0;
}

void CAnnotInfoDlg::UpdateInfo()
{
	m_annotInfoList.DeleteAllItems();
	CPDFPageAnnots pPageAnnots = m_pFxAXSDK->GetPageAnnots(m_pFxAXSDK->GetCurPage());
	if(!pPageAnnots)
	{
		MessageBox(_T("Please check the KEY license information.\n\nIf you never have a KEY license ,please contact us at sales@foxitsoftware.com"));
		return;
	}
	int nCount = pPageAnnots.GetAnnotsCount();
	for(int index = 0; index < nCount; index++)
	{
		CPDFAnnot pAnnot = pPageAnnots.GetAnnot(index); 
		m_annotInfoList.InsertItem(index, _T("Annot Obj"));
		
		CString strTemp;
		long nAnnotIndex = pPageAnnots.GetAnnotIndex(pAnnot);
		strTemp.Format(_T("%d"),nAnnotIndex + 1);
		m_annotInfoList.SetItemText(index, 0, strTemp);
		
		strTemp= pAnnot.GetType();
		m_annotInfoList.SetItemText(index, 1, strTemp); 
		
		strTemp= pAnnot.GetSubType();
		m_annotInfoList.SetItemText(index, 2, strTemp); 
	}
	
	CString str;
	str.Format(_T("Current Page Index%d / %d, Annots Count: %d\n"), m_pFxAXSDK->GetCurPage() + 1, m_pFxAXSDK->GetPageCount(), nCount);
	GetDlgItem(IDC_PAGE_INDEX_STATIC)->SetWindowText(str);
}
