// AnnotReplyDlg.cpp : implementation file
//

#include "stdafx.h"
#include "ax_annot_demo.h"
#include "AnnotReplyDlg.h"

#include "foxitpdfsdk.h"
#include "pdfpageannots.h"
#include "pdfannot.h"
#include "pdfannotreplylist.h"
#include "pdfannotreply.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAnnotReplyDlg dialog


CAnnotReplyDlg::CAnnotReplyDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CAnnotReplyDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CAnnotReplyDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}
CAnnotReplyDlg::CAnnotReplyDlg(CFoxitPDFSDK* pAXSDK, CWnd* pParent /* = NULL */)
: CDialog(CAnnotReplyDlg::IDD, pParent)
{
	m_pFxAXSDK = pAXSDK;
}

void CAnnotReplyDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAnnotReplyDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CAnnotReplyDlg, CDialog)
	//{{AFX_MSG_MAP(CAnnotReplyDlg)
	ON_BN_CLICKED(IDC_AddAnnot, OnAddAnnot)
	ON_BN_CLICKED(IDC_AddReply, OnAddReply)
	ON_BN_CLICKED(IDC_ForceRefresh, OnForceRefresh)
	ON_BN_CLICKED(IDC_GetCreatDate, OnGetCreatDate)
	ON_BN_CLICKED(IDC_Remove, OnRemove)
	ON_BN_CLICKED(IDC_RemoveAll, OnRemoveAll)
	ON_BN_CLICKED(IDC_SetReadOnly, OnSetReadOnly)
	ON_BN_CLICKED(IDC_SetCreator, OnSetCreator)
	ON_BN_CLICKED(IDC_ReplyID, OnReplyID)
	ON_BN_CLICKED(IDC_UpdateAnnotReply, OnUpdateAnnotReply)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAnnotReplyDlg message handlers

void CAnnotReplyDlg::OnAddAnnot() 
{
	// TODO: Add your control notification handler code here
	int iPage = m_pFxAXSDK->GetCurPage();
	CPDFPageAnnots pPageAnnots = m_pFxAXSDK->GetPageAnnots(iPage);
	if(!pPageAnnots)
	{
		MessageBox(_T("Please check the KEY license information.\n\nIf you never have a KEY license ,please contact us at sales@foxitsoftware.com"));
		return;
	}

	CPDFAnnot pAnnot = pPageAnnots.AddAnnot(NULL, _T("Note"), 100, 200, 200, 500);//Add annot
	if (pAnnot!= NULL)pAnnot.SetAuthor(_T("SDK USERRR"));
}

void CAnnotReplyDlg::OnAddReply() 
{
	// TODO: Add your control notification handler code here
	int iPage = m_pFxAXSDK->GetCurPage();
	CPDFPageAnnots pPageAnnots = m_pFxAXSDK->GetPageAnnots(iPage);
	if(!pPageAnnots)
	{
		MessageBox(_T("Please check the KEY license information.\n\nIf you never have a KEY license ,please contact us at sales@foxitsoftware.com"));
		return;
	}

	
	int iCount = pPageAnnots.GetAnnotsCount();
	if (iCount<=0)
	{
		MessageBox(_T("Note!\n\nThere has any annot in current page."));
		return;
	}
	CPDFAnnot pAnnot = pPageAnnots.GetAnnot(0);
	CPDFAnnotReplyList pAnnotReplies = pAnnot.GetReplyList();
	if (pAnnotReplies == NULL) 
		return;

	COleDateTime date = COleDateTime::GetCurrentTime();

	pAnnotReplies.Add(_T("FoxitUser"),_T("Add a reply"), date);
	MessageBox(_T("Add a reply to the first annot."));
	pAnnot.UpdateAnnotReplies(pAnnotReplies);
}

void CAnnotReplyDlg::OnForceRefresh() 
{
	// TODO: Add your control notification handler code here
	// see CAnnotReplyDlg::OnAddReply() 
}
void CAnnotReplyDlg::Close()
{
	this->OnClose();
}
void CAnnotReplyDlg::OnGetCreatDate() 
{
	// TODO: Add your control notification handler code here
	int iPage = m_pFxAXSDK->GetCurPage();
	CPDFPageAnnots pPageAnnots = m_pFxAXSDK->GetPageAnnots(iPage);
	if(!pPageAnnots)
	{
		MessageBox(_T("Please check the KEY license information.\n\nIf you never have a KEY license ,please contact us at sales@foxitsoftware.com"));
		return;
	}

	
	int iCount = pPageAnnots.GetAnnotsCount();
	if (iCount<=0)
	{
		MessageBox(_T("Note!\n\nThere has any annot in current page."));
		return;
	}
	CPDFAnnot pAnnot = pPageAnnots.GetAnnot(0);//GetAnnot 
	
	CPDFAnnotReplyList pAnnotReplies = pAnnot.GetReplyList();
	if (pAnnotReplies!=NULL)
	{
		int iCounts = pAnnotReplies.GetCount(); //
		if(iCounts <= 0 )
		{
			MessageBox(_T("Note!\n\nThere has any reply in the first annot."));
			return;
		}
		CPDFAnnotReply pReply = pAnnotReplies.GetItem(0);
        DATE dtDate = pReply.GetCreationDate();	
		COleDateTime date2(dtDate);
		CString sDate = date2.Format();
		CString strMessage;	
		strMessage.Format(_T("The date of the first reply created: %s"), sDate);
		MessageBox(strMessage);
	}

}

void CAnnotReplyDlg::OnRemove() 
{
	// TODO: Add your control notification handler code here
	int iPage = m_pFxAXSDK->GetCurPage();
	CPDFPageAnnots pPageAnnots = m_pFxAXSDK->GetPageAnnots(iPage);
	if(!pPageAnnots)
	{
		MessageBox(_T("Please check the KEY license information.\n\nIf you never have a KEY license ,please contact us at sales@foxitsoftware.com"));
		return;
	}

	
	int iCount = pPageAnnots.GetAnnotsCount();
	if (iCount<=0)
	{
		MessageBox(_T("Note!\n\nThere has any annot in current page."));
		return;
	}
	CPDFAnnot pAnnot = pPageAnnots.GetAnnot(0);
	
	CPDFAnnotReplyList pAnnotReplies = pAnnot.GetReplyList();
	if (pAnnotReplies!=NULL)
	{
		int iCounts = pAnnotReplies.GetCount(); 
		if (iCounts<=0)return;
		pAnnotReplies.Remove(0);
        MessageBox(_T("Remove the first reply from the first annot."));
	}
	pAnnot.UpdateAnnotReplies(pAnnotReplies);
}

void CAnnotReplyDlg::OnRemoveAll() 
{
	// TODO: Add your control notification handler code here
	int iPage = m_pFxAXSDK->GetCurPage();
	CPDFPageAnnots pPageAnnots = m_pFxAXSDK->GetPageAnnots(iPage);
	if(!pPageAnnots)
	{
		MessageBox(_T("Please check the KEY license information.\n\nIf you never have a KEY license ,please contact us at sales@foxitsoftware.com"));
		return;
	}

	
	int iCount = pPageAnnots.GetAnnotsCount();
	if (iCount<=0)
	{
		MessageBox(_T("Note!\n\nThere has any annot in current page."));
		return;
	}
	CPDFAnnot pAnnot = pPageAnnots.GetAnnot(0);
	
	CPDFAnnotReplyList pAnnotReplies = pAnnot.GetReplyList();
	if (pAnnotReplies!=NULL)
	{
		int iCounts = pAnnotReplies.GetCount(); 
		if (iCounts<=0)return;
		pAnnotReplies.RemoveAll();
		MessageBox(_T("Remove all reply from the first annot."));
	}
}

void CAnnotReplyDlg::OnSetReadOnly() 
{
	// TODO: Add your control notification handler code here
	int iPage = m_pFxAXSDK->GetCurPage();
	CPDFPageAnnots pPageAnnots = m_pFxAXSDK->GetPageAnnots(iPage);
	if(!pPageAnnots)
	{
		MessageBox(_T("Please check the KEY license information.\n\nIf you never have a KEY license ,please contact us at sales@foxitsoftware.com"));
		return;
	}

	
	int iCount = pPageAnnots.GetAnnotsCount();
	if (iCount<=0)
	{
		MessageBox(_T("Note!\n\nThere has any annot in current page."));
		return;
	}
	CPDFAnnot pAnnot = pPageAnnots.GetAnnot(0);
    pAnnot.SetReadOnly(true);
}

void CAnnotReplyDlg::OnSetCreator() 
{
	// TODO: Add your control notification handler code here
	int iPage = m_pFxAXSDK->GetCurPage();
	CPDFPageAnnots pAnnots = m_pFxAXSDK->GetPageAnnots(iPage);
	if(!pAnnots)
	{
		MessageBox(_T("Please check the KEY license information.\n\nIf you never have a KEY license ,please contact us at sales@foxitsoftware.com"));
		return;
	}

	int iCount = pAnnots.GetAnnotsCount();
	if (iCount<=0)
	{
		MessageBox(_T("Note!\n\nThere has any annot in current page."));
		return;
	}
	CPDFAnnot pAnnot = pAnnots.GetAnnot(0);

	CPDFAnnotReplyList pAnnotReplies = pAnnot.GetReplyList();
	if (pAnnotReplies == NULL) return;

	int nReplyCount = pAnnotReplies.GetCount();
	if (nReplyCount <= 0) 
	{
		MessageBox(_T("Note!\n\nThere has any reply in the first annot."));
		return;
	}
	CPDFAnnotReply pRelpy = pAnnotReplies.GetItem(0);
	pRelpy.SetReadonly(false);
	pRelpy.SetCreator(_T("new creator"));

	MessageBox(_T("Set the new creator value for the first reply item in the first annot ."));
}

void CAnnotReplyDlg::OnReplyID() 
{
	// TODO: Add your control notification handler code here
	int iPage = m_pFxAXSDK->GetCurPage();
	CPDFPageAnnots pAnnots = m_pFxAXSDK->GetPageAnnots(iPage);
	if(!pAnnots)
	{
		MessageBox(_T("Please check the KEY license information.\n\nIf you never have a KEY license ,please contact us at sales@foxitsoftware.com"));
		return;
	}


	int iCount = pAnnots.GetAnnotsCount();
	if (iCount<=0)
	{
		MessageBox(_T("Note!\n\nThere has any annot in current page."));
		return;
	}
	CPDFAnnot pAnnot = pAnnots.GetAnnot(0);
	CPDFAnnotReplyList pAnnotReplies = pAnnot.GetReplyList();
	if (pAnnotReplies == NULL) return;
	int nReplyCount = pAnnotReplies.GetCount();
	if (nReplyCount <= 0)
	{
		MessageBox(_T("Note!\n\nThere has any reply in the first annot."));
		return;
	}
	CPDFAnnotReply pRelpy = pAnnotReplies.GetItem(0);//
	int iId = pRelpy.GetReplyID();

	CString str;
	str.Format(_T("The first reply item ID of the first annot is :%d"), iId);

    MessageBox(str);
}

void CAnnotReplyDlg::OnUpdateAnnotReply() 
{
	// TODO: Add your control notification handler code here
	int iPage = m_pFxAXSDK->GetCurPage();
	CPDFPageAnnots pPageAnnots = m_pFxAXSDK->GetPageAnnots(iPage);
	if(!pPageAnnots)
	{
		MessageBox(_T("Please check the KEY license information.\n\nIf you never have a KEY license ,please contact us at sales@foxitsoftware.com"));
		return;
	}

	
	int iCount = pPageAnnots.GetAnnotsCount();
	if (iCount<=0)
		return;

	CPDFAnnot pAnnot = pPageAnnots.GetAnnot(0);
	CPDFAnnotReplyList pAnnotReplies = pAnnot.GetReplyList();
	if (pAnnotReplies == NULL)
		return;

	int nReplyCount = pAnnotReplies.GetCount();
	pAnnot.UpdateAnnotReplies(pAnnotReplies);
}
