// ExportPageDlg.cpp : implementation file
//

#include "stdafx.h"
#include "AX_Pro_Demo.h"
#include "ExportPageDlg.h"
#include "foxitpdfsdk.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CExportPageDlg dialog


CExportPageDlg::CExportPageDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CExportPageDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CExportPageDlg)
	m_pagefrom = 0;
	m_pageto = 0;
	//}}AFX_DATA_INIT
	m_pAX = NULL;
}


void CExportPageDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CExportPageDlg)
	DDX_Text(pDX, IDC_FORMPAGE_EDIT, m_pagefrom);
	DDX_Text(pDX, IDC_PAGETO_EDIT, m_pageto);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CExportPageDlg, CDialog)
	//{{AFX_MSG_MAP(CExportPageDlg)
	ON_BN_CLICKED(IDC_BTN_ONOK, OnBtnOnok)
	ON_BN_CLICKED(IDC_BTN_CANCEL, OnBtnCancel)
	ON_EN_CHANGE(IDC_FORMPAGE_EDIT, OnChangeFormpageEdit)
	ON_EN_CHANGE(IDC_PAGETO_EDIT, OnChangePagetoEdit)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CExportPageDlg message handlers
void CExportPageDlg::Init(CFoxitPDFSDK * pAX)
{
	m_pAX = pAX;
}

CString CExportPageDlg::FileDialog(BOOL IsOpen, WCHAR *Filter) 
{
	CString FileName = _T("");
	WCHAR FilePath[MAX_PATH];
	CFileDialog dlg(IsOpen, _T(".pdf"), NULL, OFN_PATHMUSTEXIST | OFN_OVERWRITEPROMPT, Filter, this);
		
	memset(FilePath, 0, sizeof(FilePath));
	
	if (IsOpen) {
		dlg.m_ofn.Flags |= OFN_FILEMUSTEXIST;
		dlg.m_ofn.lpstrTitle = _T("Open File");
	} else {
		dlg.m_ofn.lpstrTitle = _T("Save as");
	}
    dlg.m_ofn.nMaxFile = MAX_PATH; 
    dlg.m_ofn.lpstrFile = FilePath; 
	
	if (dlg.DoModal() == IDOK) {
		FileName = dlg.GetPathName();
	}
    
	return FileName;
}


BOOL CExportPageDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	m_pagefrom = m_pAX->GetCurPage()+1;
	m_pageto = m_pAX->GetCurPage()+1;
	CString strtemp;
	int nPageCout = m_pAX->GetPageCount();
	strtemp.Format(_T("of %d"),nPageCout);
	GetDlgItem(IDC_STATIC_COUNTOFPAGE)->SetWindowText(strtemp);
	UpdateData(FALSE);
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CExportPageDlg::OnBtnOnok() 
{
	// TODO: Add your control notification handler code here
	if (m_pagefrom>m_pageto)
	{
		MessageBox(_T("Input Error!"));
		return;
	}
//	WCHAR Filter[100] = _T("pdf Files (*.pdf)|*.pdf|All Files (*.*)|*.*||");
	WCHAR Filter[100] = _T("PDF Files (*.pdf)|*.PDF|All Files (*.*)|*.*|||");
	m_filepath = FileDialog(FALSE,Filter);
	CString str;
	str.Format(_T("%d-%d"),m_pagefrom,m_pageto);
	if (!m_filepath.IsEmpty())
	{
		if (m_pAX->ExportPagesToPDF(m_filepath,str))
			MessageBox(_T("Export success!"));
	}
}

void CExportPageDlg::OnBtnCancel() 
{
	// TODO: Add your control notification handler code here
	CDialog::OnCancel();
}

void CExportPageDlg::OnChangeFormpageEdit() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	if (m_pagefrom<=0||m_pagefrom>=m_pAX->GetPageCount())
	{
		MessageBox(_T("Input invalid!"));
		m_pagefrom = 1;
	}
	UpdateData(FALSE);
}

void CExportPageDlg::OnChangePagetoEdit() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	if (m_pageto<=0||m_pageto>=m_pAX->GetPageCount())
	{
		MessageBox(_T("Input invalid!"));
		m_pageto = m_pAX->GetPageCount()-1;
	}
	UpdateData(FALSE);
}
